import {select, 
        csv, 
        scaleLinear, 
        max, 
        scaleBand,
       	axisLeft,
        axisBottom,
        format} from 'd3';

//svg element and formatting

const svg = select('svg');
const height = +svg.attr('height');
const width = +svg.attr('width');

//data

csv('data.csv').then(data => {
  data.forEach(d => {
    d.population = +d.population * 1000;
  });
  render(data);
});

//reder function

const render = data =>{
  
  const xVal = d => d.population;
  const yVal = d => d.country;
  
//   margins
  
  const margin = {left: 162, right: 100, top: 60, bottom: 60};
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height -margin.top - margin.bottom;
  
  
// scaling x and y
  
  const xScale = scaleLinear()
    .domain([0, max(data, xVal)])
  	.range([0, innerWidth]); 
  const yScale = scaleBand()
  	.domain(data.map(yVal))
  	.range([0, innerHeight])
  	.padding(.05);

// x tick fromatting
  
  const xAxisTick = n => format('.3s')(n)
    .replace('G', 'B');
  
  const xAxis = axisBottom(xScale)
  	.tickFormat(xAxisTick)
    .tickSize(-innerHeight + 2);
  
  const g = svg.append('g')
  	.attr('transform', `translate(${margin.left},${margin.top})`);
  
  g.append('g').call(axisLeft(yScale))
    .selectAll('.domain, .tick line').remove();
  
// x Axis group element
  
 const xAxisG =  g.append('g').call(xAxis)
    .attr('transform', `translate(0,${innerHeight})`);
 
    xAxisG.select('.domain').remove();
  	
  	xAxisG.append('text')
      .text('realness')
      .attr('class', 'xTitle')
  		.attr('x', innerWidth / 2)
  		.attr('y', +53);
  
// rectangles
  
  g.selectAll('rect').data(data)
		.enter().append('rect')
  		.attr('y', d => yScale(yVal(d)))
			.attr('width', d => xScale(xVal(d)))
			.attr('height', yScale.bandwidth());
  
//title
  
  g.append('text').text('Top 10 realist countries')
    .attr('class', 'title')
  	.attr('y', -10)
  	.attr('x', width / 6);
};